

dofile"./protocol/GB28181/Script/Lua/SipParser.lua"
dofile"./protocol/GB28181/Script/Lua/SipProcess.lua"
dofile"./protocol/GB28181/Script/Lua/XmlParser.lua"
print("GB28181 parse command file load!!");

--[[ļ]]
--local f = io.open("debug.txt", "w")
--f:write("\n")
--f:close()
--[[
ֵ˵
enum ATParserState
{
	ATParser_Success = 0,			///< ɹ
	ATParser_NotComplete = 1,		///< ݲ, Ҫ´½
	ATParser_Failed = 2,			///< ʧ 
	ATParser_MediaData = 3,			///< Ϊý
	ATParser_RepeatMessage = 255,   ///< Ϊظý
};
--]]

--print = function(s)
--local f = io.open("debug.txt", "a")
--f:write(s)
--f:write("\n")
--f:close()
--end

messageSet = {}

--c++
function parseCommand(buf, parseRet) 
	local s = buf:asCString();
	--print(s);

	if messageSet[s] then
		print("@@@@@@recv a repeat message!!!!!!!!!!!");
		return ATParser_RepeatMessage, buf:len();
	end

	messageSet[s] = 1
	
	local endFlag, endFlage = string.find(s, "\r\n\r\n");
	if not endFlag then return 1, 0 end
	
	local sipValue = {}
	local ret = parseSip(string.sub(s, 0, endFlag) , parseRet, sipValue);
	if not ret then
		print("parse sip header error");
		return 2, buf:len();
	end

	ret = SipProcess(sipValue, parseRet)

	if not ret then return 2, 0 end

	if sipValue["ContentLength"] ~= 0 and sipValue["ContentType"] == "Application/MANSCDP+xml" then
		local xmls, xmle = string.find(s, "%<%?xml ")
		xmle = xmls + sipValue["ContentLength"] - 1;
		local xml = string.sub(s, xmls, xmle);
		--print("xml info:"..xml);
		
		local xmltable = {}
		parseXml(xml, xmltable)
		local dir = ""
		--printXmlValue(xmltable, dir)
		
		--xmlϢн
		if xmltable["Notify"] then
		
			local root = xmltable["Notify"]
			local cmdType = root["CmdType"]["@Data"]
			
			if cmdType == "Keepalive" then
				OnKeepalive(root, parseRet)
			elseif cmdType == "Alarm" then
				OnAlarm(root, parseRet)
			end
			
		elseif xmltable["Response"] then
			local root = xmltable["Response"]
			local cmdType = root["CmdType"]["@Data"]
			
			if cmdType == "DeviceInfo" then
				OnDeviceInfo(root, parseRet)
			elseif cmdType == "DeviceStatus" then
				OnDeviceStatus(root, parseRet)
			elseif cmdType == "Catalog" then
				OnCatalog(root, parseRet)
			elseif cmdType == "DeviceControl" then
				OnDeviceControl(root, parseRet)
			elseif cmdType == "RecordInfo" then
				OnRecordInfo(root, parseRet)
			elseif cmdType == "DeviceConfig" then
				OnDeviceConfig(root,parseRet)
			elseif cmdType == "ConfigDownload"
				OnConfigDownload(root,parseRet)
			end
		else
		
		end
		--parseRet:pushCString("content", xml)
	end
	
	return 0, buf:len();
end

function OnKeepalive(root, parseRet)
	print("OnKeepalive")
	parseRet:pushCString("_type", "Keepalive")
end

function OnAlarm(root, parseRet)
	print("OnAlarm")
	parseRet:pushCString("_type", "Alarm")
end

function OnDeviceInfo(root, parseRet)
	print("OnDeviceInfo")
	if root["Result"]["@Data"] == "OK" then
		parseRet:pushCString("@_FACTORY", root["Manufacturer"]["@Data"])
		parseRet:pushCString("@_DEVICE_TYPE", root["Model"]["@Data"])
		parseRet:pushCString("@_SOFTVERSION", root["Firmware"]["@Data"])
		
		print("_type = ".."DeviceInfo")
		parseRet:pushCString("_type", "DeviceInfo")
	end
end

function OnDeviceStatus(root, parseRet)
	print("OnDeviceStatus")
	if root["Result"]["@Data"] == "OK" then
		if root["Alarmstatus"] and root["Alarmstatus"]["@Attr"] then
			local alarmId = nil
			num = root["Alarmstatus"]["@Attr"]["Num"] + 0
			if num == 1 then
				alarmId = root["Alarmstatus"]["Item"]["DeviceID"]["@Data"]
			elseif num > 1 then
				
				alarmId = "["..root["Alarmstatus"]["Item"][1]["DeviceID"]["@Data"]
				for k = 2,num do
					alarmId = alarmId..","
					tempId = root["Alarmstatus"]["Item"][k]["DeviceID"]["@Data"]
					alarmId = alarmId..tempId
				end
				alarmId = alarmId.."]"
			end
			parseRet:pushCString("AlarmID", alarmId)
			print(alarmId)
		end
		
		print("_type = ".."DeviceStatus")
		parseRet:pushCString("_type", "DeviceStatus")
	end
end

function OnCatalog(root, parseRet)
	print("OnCatalog")
	total = root["SumNum"]["@Data"]
	parseRet:pushCString("@_WAIT_MSG_COUNT", total)
	total = total + 0
	if total ~= 0 then
		local num = root["DeviceList"]["@Attr"]["Num"]
		parseRet:pushCString("@_RECVED_MSG_COUNT", num)
		num = num + 0
		
		--עɹʱʼ
		local channelId = ATLuaConfig:instance():getConfig("ChannelID")
		
		--ȥ"]"
		if channelId then
			channelId = string.gsub(channelId, "%]", "")
			--channelId = string.gsub(channelId,  "[%","")
		else
			channelId = "["
		end
		
		if num ~= 0 then
			if num > 1 then
				for k = 1,num do
					if root["DeviceList"]["Item"][k]["Status"]["@Data"] == "ON" then
						tempId = root["DeviceList"]["Item"][k]["DeviceID"]["@Data"]
						if channelId == "[" then
							channelId = channelId..tempId
						else
							channelId = channelId..","..tempId
						end
					end
				end
			else 
				if root["DeviceList"]["Item"]["Status"]["@Data"] == "ON" then
					tempId = root["DeviceList"]["Item"]["DeviceID"]["@Data"]
					if channelId == "[" then
						channelId = channelId..tempId
					else
						channelId = channelId..","..tempId
					end
				end
			end
			channelId = channelId.."]"

			-- ֻһͨʱȥ
			if not string.find(channelId, ",") then
				channelId = string.gsub(channelId, "%[", "")
				channelId = string.gsub(channelId, "%]", "")
			end
			print(channelId)
		    if string.find(channelId, "]") then
			    if string.find(channelId, "[") then
				else
				    channelId =  "["..channelId
			    end
			end
			print(channelId)
			parseRet:pushCString("ChannelID", channelId)
		end
	end
	
	print("_type = ".."Catalog")
	parseRet:pushCString("_type", "Catalog")

end

function OnDeviceConfig(root,parseRet)
	print("OnDeviceConfig")
	parseRet:pushCString("_type", "OnDeviceConfig")
end


function OnDeviceControl(root, parseRet)
	print("OnDeviceControl")
	print(root["DeviceID"]["@Data"])

	parseRet:pushCString("_type", "DeviceControl")
end

function OnRecordInfo(root, parseRet)
	print("OnRecordInfo")
	total = root["SumNum"]["@Data"]
	parseRet:pushCString("@_WAIT_MSG_COUNT", total)
	total = total + 0
			
	if total ~= 0 then
		local num = root["RecordList"]["@Attribute"]["Num"]
		parseRet:pushCString("@_RECVED_MSG_COUNT", num)
		num = num + 0
		
		--עɹʱʼ
		local Record_len = ATLuaConfig:instance():getConfig("Record_len") + 0
		if Record_len > 120 then
			parseRet:pushCString("_type", "RecordInfo")
			return
		end
		
		if num == 1 then
			value = root["RecordList"]["Item"]["StartTime"]["@Data"]
			local iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
			local StartTime = os.time{year=iyear,month=imonth,day=iday,hour=ihour,min=iminute,sec=isecond}

			value = root["RecordList"]["Item"]["EndTime"]["@Data"]
			iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
			local EndTime = StartTime + 20;

			if EndTime-StartTime > 10 then
				Record_len = EndTime-StartTime-10
			else
				Record_len = 0
			end
			parseRet:pushCString("StartTime", StartTime)
			parseRet:pushCString("EndTime", EndTime)
			parseRet:pushCString("Record_len", Record_len)
			
		elseif num > 1 then
			for k = 1, num do
				if Record_len > 120 then
					break
				end
				value = root["RecordList"]["Item"][k]["StartTime"]["@Data"]
				local iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
				local StartTime = os.time{year=iyear,month=imonth,day=iday,hour=ihour,min=iminute,sec=isecond}
				
				value = root["RecordList"]["Item"][k]["EndTime"]["@Data"]
				iyear,imonth,iday,ihour,iminute,isecond = string.match(value, "(%d+)-(%d+)-(%d+)T(%d+):(%d+):(%d+)")
				local EndTime = StartTime + 20;

				if EndTime-StartTime > 10 then
					Record_len = EndTime-StartTime-10
				else
					Record_len = 0
				end
				parseRet:pushCString("StartTime", StartTime)
				parseRet:pushCString("EndTime", EndTime)
				parseRet:pushCString("Record_len", Record_len)
			end
		end
	end
	print("_type = ".."RecordInfo")
	parseRet:pushCString("_type", "RecordInfo")
end

function OnConfigDownload(root, parseRet)
	if root["VideoParamConfig"] then
	  parseRet:pushCString("_type", "VideoParamConfig")
        elself root["AudioParamConfig"] then
          parseRet:pushCString("_type", "VideoParamConfig")
	else
	  parseRet:pushCString("_type", "BasicParam")
	end
	
	return true;
end
