
--[[
	ȨУؾ
	ãɺ
	li_haitao create
--]]

--[[
	sipValue = {}
	key-value,ʹǰȼkeyӦvalueǷΪnil

	SipMethord
	SipStaus
	sipId
	sipDomain
	FromId
	FromDomain
	FromTag
	ToId
	ToDomain
	ToTag
	SeqValue
	SeqType
	CallId
	Via
	Expires
	ContentLength
	ContentType
	
	username
	realm
	nonce
	uri
	response
	algorithm
	opaque
	qop
	nc
--]]

--ֵͨڴӡϢ
debug_level = 1

function sipprint(buf)
	if debug_level==2 then
		local f = io.open("./debug.txt", "a")
		f:write(buf)
		f:write("\n")
		f:close()
	elseif debug_level==1 then
		print(buf)
	else
		--do nothing
	end
	
end


--עRequest-Line
function parseREGISTER(s, parseRet, sipValue) 
	local ret = false
	local sipServerId, sipServerDomain = string.match(s, "sip:(%d+)@([%w%:%.]+)")
	
    if sipServerId and sipServerDomain then
		sipValue["sipId"] = sipServerId
		sipValue["sipDomain"] = sipServerDomain
		sipValue["SipMethord"] = "REGISTER"
		ret = true
	end
	return ret
end

function parseMESSAGE(s, parseRet, sipValue)
	sipValue["SipMethord"] = "MESSAGE"
	return true
end

--parseFrom("From: <sip:101200000780000@cmcc.com>;tag=258813199")
function parseFrom(s, parseRet, sipValue) 
	local FromId, FromDomain = string.match(s, "(%d+)@(.*)>")
	sipValue["FromId"] = FromId
	sipValue["FromDomain"] = FromDomain
	
	if not string.find(s, "tag") then
		return true
	end
	
	local FromTag = string.match(s, "=(%w+)")
	sipValue["FromTag"] = FromTag	
	return true
end

--parseTo("To: <sip:101200000780000@cmcc.com>;tag=i0h1r2dp")
function parseTo(s, parseRet, sipValue) 
	local ToId, ToDomain = string.match(s, "(%d+)@(.*)>")
	sipValue["ToId"] = ToId
	sipValue["ToDomain"] = ToDomain
	
	if not string.find(s, "tag") then
		return true
	end
	
	local ToTag = string.match(s, "=(%w+)")
	sipValue["ToTag"] = ToTag	
	return true
end

--parseCseq("CSeq: 1 REGISTER")
function parseCseq(s, parseRet, sipValue)
	local SeqValue, SeqType = string.match(s, "(%d+)%W*(%w+)")
	sipValue["SeqValue"] = SeqValue
	sipValue["SeqType"] = SeqType
	return true
end

--parseCallID("Call-ID: 563286861@172.11.2.174")
function parseCallID(s, parseRet, sipValue) 
	local CallId = string.match(s,"Call%-ID:%W*(.*)")
	sipValue["CallId"] = CallId
	return true
end

--parseVia("Via: SIP/2.0/UDP 172.11.2.174:5060;branch=z9hG4bK325314323;rport=5060")
function parseVia(s, parseRet, sipValue) 
	local Via = string.match(s,"Via:%W*(.*)")
	sipValue["Via"] = Via
	return true
end

--parseExpire("Expires: 3600")
function parseExpires(s, parseRet, sipValue) 
	local Expires = string.match(s, "Expires:%W*(%d+)")
	Expires = Expires + 0
	sipValue["Expires"] = Expires
	return true
end

--parseContentLength("Content-Length: 0")
function parseContentLength(s, parseRet, sipValue)
	local ContentLength = string.match(s, "Content%-Length:%W*(%d*)");
	ContentLength = ContentLength + 0
	sipValue["ContentLength"] = ContentLength
	return true
end

--parseContentType("Content-Type: Application/MANSCDP+xml")
function parseContentType(s, parseRet, sipValue) 
	local ContentType = string.match(s, "Content%-Type:%W*(.*)");
	sipValue["ContentType"] = ContentType
	return true
end

--parseAuthorization("Authorization: Digest username="010000000170000", realm="10.19.2.125", nonce="1362987110148893", uri="sip:10.19.2.125", response="478450a82e86498a52ee3844461b8baa", algorithm=MD5, cnonce="0a4f113b", opaque="ccs2019583842", qop=auth, nc=00000001")
function parseAuthorization(s, parseRet, sipValue) 
	for key,value in string.gmatch(s, "([%w%-%.]+)%W*[:=]%W*([%w%-%.%:%@]+)") do
		sipValue[key] = value
	end
	return true
end

--parseSIP2("MESSAGE sip:101200000780000@cmcc.com SIP/2.0")
function parseSIP2(s, parseRet, sipValue) 
	local SipStaus = string.match(s, "SIP/2%.0%W*(%d+) ");
	sipValue["SipStaus"] = SipStaus
	sipValue["SipMethord"] = "SIP"
	return true
end

function parseINVITE(s, parseRet, sipValue)
	sipValue["SipMethord"] = "INVITE"
	return true
end

function parseACK(s, parseRet, sipValue)
	sipValue["SipMethord"] = "ACK"
	return true
end

function parseBYE(s, parseRet, sipValue)
	sipValue["SipMethord"] = "BYE"
	return true
end

function parseINFO(s, parseRet, sipValue)
	sipValue["SipMethord"] = "INFO"
	return true
end

function parseOther(...) 
	return true
end

local sipHandler = {}

--ӦRequest_line
sipHandler["REGISTER"] 			= parseREGISTER;
sipHandler["MESSAGE"] 			= parseMESSAGE;
sipHandler["SIP"] 				= parseSIP2;
sipHandler["INVITE"]			= parseINVITE;
sipHandler["ACK"]				= parseACK;
sipHandler["BYE"]				= parseBYE;
sipHandler["INFO"]				= parseINFO;
--ӦHeader
sipHandler["Via"] 				= parseVia;
sipHandler["Call-ID"] 			= parseCallID;
sipHandler["From"] 			    = parseFrom;
sipHandler["To"] 				= parseTo;
sipHandler["CSeq"] 			    = parseCseq;
sipHandler["Content-Length"] 	= parseContentLength;
sipHandler["Authorization"] 	= parseAuthorization;
sipHandler["Content-Type"] 	    = parseContentType;
sipHandler["Expires"] 			= parseExpires;

--
function parseSip(sipMessage, parseRet, sipValue)
	local ret = true
    for w in string.gmatch(sipMessage, "%C+") do
		local header = string.match(w, "[%w%-%.]+");
		local func = sipHandler[header];
		if not func then 
			sipprint("find handler fail, header:"..header)
			func = parseOther
		end
		if not func(w, parseRet, sipValue) then
			sipprint("w= "..w)
			ret = false
		end
	end
--	if sipValue["SipMethord"] == nil then
--		return nil
--	else
--		return ret
--	end
	return ret
end

function printSip(sipValue)
	for key in pairs(sipValue) do
		print("sipValue["..key.."] = "..sipValue[key])
	end
end


